<?
/*
   KISGB - a Guest Book script written in PHP.
   Copyright (C) 2001 Gaylen Fraley
   gfraley5@earthlink.net

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
/****************************************************************
KISGB DOES NOT REQUIRE THAT YOU USE THIS!!!!!!
****************************************************************/
/*
	The logfile class allows you to write out a log from the index.php
	file or the addtogb.php file.  It can be used elsewhere, but it really
	doesn't make sense to.  To use it, you must include it AFTER the 
	language file and config files are included.
	
	Example usage:
	
	$objLog = new logfile();
	$objLog->logvars[] = getenv(REMOTE_ADDR);
	$objLog->logvars[] = $HTTP_USER_AGENT;	
	$objLog->logvars[] = date($date_format);
	$objLog->logvars[] = date($time_format);
	$objLog->logvars[] = $PHP_SELF;
	$objLog->writelog();

	The default logfile name is "./kisgb.log.php" and the deafult separator is
	a vertical bar "|".  You can override both of these when you instantiate the
	class, as in:
	
	$objLog = new logfile("./kisgb.personallog.php","~");	
	
	This would write entries to ./kisgb.log.php file and would create it, if
	it doesn't already exist.  This would track visitors: ip, browser, date/time,
	and url.  
	
	You control the placement of this code in the index.php and addtogb.php files.
	This is really specialized code for very specific tracking purposes and to 
	demonstrate it, I have included a index_with_log.php that will show 
	where you might want to place it.  To test it, after setting up KISGB, type
	http://your.url/kisgb/index_with_log.php , instead of 
	http://your.url/kisgb/index.php .  You shoud then see a kisgb.log.php file
	in your kisgb directory with the tracking variables in it.
*/

class logfile
{
	var $logvars
		,$path_to_log
		,$separator;
	
	function logfile($log_file="./kisgb.log.php",$sep="|")
	{
		$this->path_to_log = $log_file;
		$this->separator = $sep;
	}

	function writelog()
	{
		GLOBAL $unable_to_access_file_msg;
		$log = @fopen($this->path_to_log,"a") or die($unable_to_access_file_msg." ".$this->path_to_log);
		@flock($log,1);
		foreach ($this->logvars as $strname)
		{
			@fwrite($log,$this->separator.$strname);
		}
		@fwrite($log,"\n");
		@flock($log,3);
		@fclose($log);
	}

	
	function showvars()
	{
		foreach ($this->logvars as $strname)
		{
			echo $strname."<br>";
		}
	}
}
?>
