<?php
/*
   KISGB - a Guest Book script written in PHP.
   Copyright (C) 2001 Gaylen Fraley
   gfraley5@earthlink.net

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
require("functions.php");
check_php_version();
session_start();
session_register('temp_language');
session_register('temp_theme');
require("config.php");
require("classes.php");
/*************************************************************************
THIS IS A DEMONSTRATION OF THE LOGGING FUNCTION.  YOU MIGHT WANT TO KNOW
HOW OFTEN YOUR PAGES ARE BEING BROWSED AND BY WHOM AND BY WHICH BROWSERS.
*************************************************************************/
$objLog = new logfile("./kisgb.personallog.php","~");
$objLog->logvars[] = getenv(REMOTE_ADDR);
$objLog->logvars[] = $HTTP_USER_AGENT;	
$objLog->logvars[] = date($date_format);
$objLog->logvars[] = date($time_format);
$objLog->logvars[] = $PHP_SELF;
$objLog->writelog();
/*************************************************************************
END OF LOGGING SAMPLE CODE.
*************************************************************************/
###########################################################################
# Override the settings in config if meta controls are set.               #
###########################################################################
if ($hide_all) {
	$show_name = false;
	$show_email = false;
	$show_home = false;
	$show_pic = false;
	$show_icq = false;
	$show_aim = false;
	$show_yim = false;
	$show_msn = false;
	$show_nation = false;
	$show_ip = false;
	$show_private = false;
}
else if ($show_all) {
	$show_name = true;
	$show_email = true;
	$show_home = true;
	$show_pic = true;
	$show_icq = true;
	$show_aim = true;
	$show_yim = true;
	$show_msn = true;
	$show_nation = true;
	$show_ip = true;
	$show_private = true;
}
if ($allow_carriage_returns) $allowed_html_tags_no_img = $allowed_html_tags_no_img."<br>";
###########################################################################
# If no guestbook exists, assume that this is a new install and launch    #
# the installer.                                                          #
###########################################################################
if (!file_exists($path_to_gb)) {
header("Location: setup");
exit;
}
###########################################################################
if (isset($tmp_theme)) $temp_theme = $tmp_theme;
else if ($temp_theme>"");
else $temp_theme=$theme;
$theme = $temp_theme;
if (!file_exists("$path_to_themes/$theme")) $theme = "default.thm.php";
require("$path_to_themes/$theme");
if (!isset($view)) $view = "view";
if (isset($tmp_lang)) $temp_language = $tmp_lang;
else if ($temp_language>"");
else $temp_language=$language;
$language = $temp_language;
require("$path_to_languages/$language");
require("filters.inc.php");
$rmt_ip = $HTTP_SERVER_VARS["REMOTE_ADDR"];
if ($secure_site) {
	if(!isset($PHP_AUTH_USER)||!($PHP_AUTH_USER==$secure_site_id && $PHP_AUTH_PW==$secure_site_pw)) {
		header("WWW-Authenticate: Basic realm=\"KISGB\""); 
		header("HTTP/1.0 401 Unauthorized"); 
		echo "<html><body><table align=center border=$Awindow_border width=\"50%\"><tr><td align=center style=\"background-color:$Awindow_background_color;color:$Awindow_text_color;border-color:$Awindow_border_color;font-size:$Atable_font_size;border-width:$Awindow_border_width\"><b>$not_authorized_msg</b></td></tr></table></body></html>";
		exit;
 	 }
}
if (!file_exists("$path_to_gb")) {
	$write_header = 1;
	$header = "";
	for ($i=1;$i<16;$i++) {
		if ($i==1) $comma = "";
		else $comma = ",";
		$header .= $comma.${"col$i"};
	}
	$header .= "\n";
	$fp = fopen("$path_to_gb","a") or die("$unable_to_access_file_msg $path_to_db");
	flock($fp,1);
	if ($write_header) fwrite($fp,$header);
	flock($fp,3);
	fclose($fp);
}

$handle=opendir($path_to_themes);
$theme_sb = "";
$selected_theme = explode('.',$theme);
$cnt = 0;
while (($file = readdir($handle))!==false) {
	if ($file == '.'||$file == '..') continue;
	$thm = explode('.',$file);
	if (chop($thm[1]) != "thm") continue;
	$cnt++;
	if ($cnt==1) {
		$theme_sb = "<select name=theme onchange=\"location.replace('$PHP_SELF?action=view&tmp_theme='+this.options[this.selectedIndex].value);\">\n";	}
	$selected = "";
	if ($thm[0] == $selected_theme[0]) $selected = "selected"; 
	$theme_sb .= "<option value=\"$file\" $selected>$thm[0]</option>\n";
}
if ($cnt>0) $theme_sb .= "</select>\n";
closedir($handle);

$handle=opendir($path_to_languages);
$lang_sb = "";
$selected_lang = explode('.',$language);
$cnt = 0;
while (($file = readdir($handle))!==false) {
	if ($file == '.'||$file == '..') continue;
	$lang = explode('.',$file);
	if (chop($lang[1]) != "lang") continue;	
	$cnt++;
	if ($cnt==1) {
		$lang_sb = "<select name=language onchange=\"location.replace('$PHP_SELF?action=view&tmp_lang='+this.options[this.selectedIndex].value);\">\n";	}
	$selected = "";
	if ($lang[0] == $selected_lang[0]) $selected = "selected"; 
	$lang_sb .= "<option value=\"$file\" $selected>$lang[0]</option>\n";
}
if ($cnt>0) $lang_sb .= "</select>\n";
closedir($handle);

echo "<meta http-equiv=\"Content-Type\" content=\"text/html; $charset\"/>";
?>
<html>
<head>
<title><?=$guestbook_name?></title>
<script>
	var msa = 0;
	function validate() {
		error = 0;
		<?if ($hide_all || ($require_name && !$show_name)) $require_name = false; ?>
		<?if ($hide_all || ($require_email && !$show_email)) $require_email = false; ?>
		<?if ($hide_all || ($require_nation && !$show_nation)) $require_nation = false ?>		
		<?if ($require_name) echo "if (document.forms[0].name.value == \"\") error ++;"; ?>
		<?if ($require_email) echo "if (document.forms[0].email.value == \"\") error ++;"; ?>
		<?if ($require_nation) echo "if (document.forms[0].nation.value == \"blank.gif\") error ++;"; ?>		
		if (error)	{
			alert("<?=$required_field_missing_msg?>");
			return false;
		}
		var re = /^[_\.\'0-9a-zA-Z-]+@([0-9a-zA-Z][0-9a-zA-Z-]+\.)+[a-zA-Z]{2,4}$/;
		<?if ($require_email) { ?>
		if (document.forms[0].email.value.search(re) == -1) {
			alert("<?=$invalid_email_msg?>");
			return false;
		}
		<?}?>
		return true;
	}
</script>


<? # begin action=add
if ($action=='add') { 
	$ip = getenv('REMOTE_ADDR');
	for ($i=0;$i<count($badips);$i++) { 
		if (@eregi("$badips[$i]", $ip)) { 
		?>
		<table align=center border=2 width="50%" bgcolor=lightyellow>
		<tr><td align=center><font color=red><b>$banned_ip_msg
		<br>
		<br>
		<a href="index.php?action=view"><?=$label_back?></a></b></font>
		</td></tr>
		</table>
		<?
		exit;
		}
	}

	if (whoami() && $show_admin_menu) $admin_menu = "<a href=\"admin.php\" onMouseOver='status=\"$label_admin_menu\";return true;' onClick=\"if (this.blur) this.blur();\">$label_admin_menu</a>";
	else $admin_menu = "";

	?>	
	<style>
		BODY {
			<? if ($body_background_image > "") {
				echo 'background-image : url('.$body_background_image.');';
			}
			 else if ($body_background_color > "") {
				echo 'background-color : '.$body_background_color.';';
			}
			?>
		}
		TD	{
			color: <?echo $Awindow_text_color; ?>;
			vertical-align : top;
			background-color : <?echo $Awindow_background_color; ?>;
			border-width:0;
			border-color:<?echo $Awindow_border_color; ?>;
			font-size:<?echo $Atable_font_size; ?>;
		}	
		TH {
			background-color : <?echo $Awindow_title_background_color; ?>;
			color : <?echo $Awindow_title_text_color; ?>;		
		}
	</style>
</head>
<body VLINK="<?echo $Alink_visited_color?>" LINK="<?echo $Alink_color?>" ALINK="<?echo $Alink_active_color?>">

	<form action="addtogb.php" method=post onSubmit="return validate()">
	<table align=center height="1%" width=<?="$Atable_width"?> cellpadding=<?="$Awindow_cellpadding"?>  cellspacing=<?="$Awindow_cellspacing"?> border=<?="$Awindow_border"?> rules=none>
	<tr><td align=left style="background-color:<?="$Awindow_title_background_color"?>;color:<?="$Awindow_title_text_color"?>;">&nbsp;&nbsp;<?="$Awindow_title"?></td>
	<td align=right style="background-color:<?="$Awindow_title_background_color"?>;color:<?="$Awindow_title_text_color"?>;"><a href="<?echo $PHP_SELF?>" onMouseOver="status='<?=$label_view_gb?>';return true;" onClick="if (this.blur) this.blur();":><?=$label_view_gb?></a></td>
	<? if ($admin_menu>"") { ?>
	<td align=right style="background-color:<?="$Awindow_title_background_color"?>;color:<?="$Awindow_title_text_color"?>;"><?=$admin_menu?></td> <? } ?> </tr>
	</table>		
	<table width=<?="$Atable_width"?> height=<?="$Atable_height"?> rules=none align=center  cellpadding=<?="$Awindow_cellpadding"?> cellspacing=<?="$Awindow_cellspacing"?> border=<?="$Awindow_border"?>>
	<?
	if (($show_name||$show_all)&&!$hide_all) {
		echo "<tr><td>&nbsp;&nbsp;$label_name";
		if ($require_name) echo " *";
		echo "<td><input name=name size=30 maxlength=50>";
	}
	else echo "<input type=hidden name=name value=\" \">";	
	if (($show_email||$show_all)&&!$hide_all) {
		echo "<tr><td>&nbsp;&nbsp;$label_email";
		if ($require_email) echo " *";
		echo "<td><input name=email size=30 maxlength=50>";
	}
	else echo "<input type=hidden name=email value=\" \">";			
	if (($show_home||$show_all)&&!$hide_all) {
		echo "<tr><td>&nbsp;&nbsp;$label_home<td><input name=home size=30 maxlength=50 value=$def_home>";
	}
	else echo "<input type=hidden name=home value=\" \">";				
	if (($show_pic||$show_all)&&!$hide_all) {
		echo "<tr><td>&nbsp;&nbsp;$label_pic<td><input name=pic size=30 maxlength=50 value=$def_pic>";
	}
	else echo "<input type=hidden name=pic value=\" \">";					
	if (($show_icq||$show_all)&&!$hide_all) {
		echo "<tr><td>&nbsp;&nbsp;".$label_icq."<td><input name=icq size=30 maxlength=15>";
	}
	else echo "<input type=hidden name=icq value=\" \">";
	if (($show_aim||$show_all)&&!$hide_all) {
		echo "<tr><td>&nbsp;&nbsp;".$label_aim."<td><input name=aim size=30 maxlength=30>";
	}
	else echo "<input type=hidden name=aim value=\" \">";
	if (($show_yim||$show_all)&&!$hide_all) {
		echo "<tr><td>&nbsp;&nbsp;".$label_yim."<td><input name=yim size=30 maxlength=30>";
	}
	else echo "<input type=hidden name=yim value=\" \">";
	if (($show_msn||$show_all)&&!$hide_all) {
		echo "<tr><td>&nbsp;&nbsp;".$label_msn."<td><input name=msn size=30 maxlength=30>";
	}
	else echo "<input type=hidden name=msn value=\" \">";
	if (($show_nation||$show_all)&&!$hide_all) {	
		echo "<tr><td>&nbsp;&nbsp;$label_nation";
		if ($require_nation) echo " *";
		echo "<td>";
		require("nation.html");
		echo "</td></tr>";
	}
	else echo "<input type=hidden name=nation value=\" \">";	
	if (($show_ip||$show_all)&&!$hide_all) {	
	echo "<tr><td>&nbsp;&nbsp;$label_ip<td>".getenv('REMOTE_ADDR');
	}
	?>
	<tr><td>&nbsp;&nbsp;<?echo $label_comment ?><td><textarea name=comments cols=<?echo $comment_cols ?> rows=<?echo $comment_rows ?> wrap=soft></textarea>
	<?
	if (($show_private||$show_all)&&!$hide_all) {
		echo "<tr><td>&nbsp;<td>$label_privatemessage&nbsp;<input type=checkbox name=private>";
	}
	else echo "<input type=hidden name=private value=\" \">";
	if (!$hide_all) echo "<tr><td colspan=2 align=left>&nbsp;&nbsp;<b><i>$label_requiredfield<tr><td colspan=2>&nbsp;</td></tr>";

		if ($allow_smileys) {
			echo "<tr><td colspan=2 align=center><input type=button value=\"Smileys\" onClick=\"window.open('./showsmileys.php','smileys','width=300,height=600,scrollbars');\"></td></tr>";
		}
	?>
	<tr><td colspan=2>&nbsp;</td></tr>
	<tr><td colspan=2 align=center><input type=submit value="<?echo $add_btn_text;?>">
	</td>
	</tr>
	</table>
<?
	if (($show_name||$show_all)&&!$hide_all) {
		echo "<script>\n";
		echo "document.forms[0].name.focus();\n";
		echo "</script>\n";
	}
?>

<? }  #end action=add
# begin action=view
else if ($action=='view'||$action=='') { ?>
	<style>
		BODY {
			<? if ($body_background_image > "") {
				echo 'background-image : url('.$body_background_image.');';
			}
			 else if ($body_background_color > "") {
				echo 'background-color : '.$body_background_color.';';
			}
			?>
		}
		td		{
			font-size:<?echo $Vtable_font_size; ?>;
			border-width:0;
		}
		#td1	{
			color: <?echo $Vwindow_text_color1; ?>;
			<? if ($Vwindow_background_image1 > "") {
				echo 'background-image : url('.$Vwindow_background_image1.');';
			}
			 else if ($Vwindow_background_color1 > "") {
				echo 'background-color : '.$Vwindow_background_color1.';';
			}
			?>
			border-width:<?echo $Vwindow_border_width; ?>;
			border-color: <?echo $Vwindow_border_color1; ?>;
		}
		#td2	{
			color: <?echo $Vwindow_text_color2; ?>;
			<? if ($Vwindow_background_image2 > "") {
				echo 'background-image : url('.$Vwindow_background_image2.');';
			}
			 else if ($Vwindow_background_color2 > "") {
				echo 'background-color : '.$Vwindow_background_color2.';';
			}
			?>
			border-width:<?echo $Vwindow_border_width; ?>;
			border-color: <?echo $Vwindow_border_color2; ?>;
		}
		TH {
			background-color : <?echo $Vwindow_title_background_color; ?>;
			color : <?echo $Vwindow_title_text_color; ?>;		
		}
		<? if (!$underline_hyperlinks) { ?>
			a:link {text-decoration:none;}
			a:visited {text-decoration:none;}
			a:active {text-decoration:none;}			
		<? } ?>
	</style>
</head>
<body VLINK="<?echo $Vlink_visited_color?>" LINK="<?echo $Vlink_color?>" ALINK="<?echo $Vlink_active_color?>">
<form>
<?
    $idselector = 0;
	$row = 0;
	$entries = 0;
	$private_entries = 0;
	$tmp_data = array();
	$fp = fopen("$path_to_gb","r") or die("Unable to access $path_to_db");
	flock($fp,1);
	$rn = 0;
	while ($data = fgetcsv($fp,4096,",")) {
		$row++;
		if ($row>1) {
			$num = count($data);
			if ($num<15) $data[14] = "";
			if ($data[14]=="on"&&$data[0]>"") $private_entries++;			
			else if ($data[0]>"") {
				$rn++;
				$entries++;
				if ($allow_carriage_returns) $data[13] = nl2br($data[13]);
				$data[13] = wordwrap($data[13],$Vtable_max_comment_width,"\n",1);
				$data[13] = str_replace("&amp;", "&", $data[13]);					
				for ($c=0;$c<$num;$c++) {
					$tmp_data[$rn][$c] = $data[$c];
				}
			}
		}
	}
	flock($fp,3);
	fclose($fp);
	echo "<center>";
	if ($use_intro) {
		echo "<table style=\"font-size:$Intro_font_size;color:$Intro_text_color;background-color:$Intro_background_color;color:$Intro_text_color;border-color:$Intro_border_color;\" width=\"$Intro_width\" height=\"$Intro_height\" border=\"$Intro_border\" rules=none cellpadding=0 cellspacing=0><tr><td><b>$intro_text</b></td></tr></table>";
	}

	$label_reverse_display = htmlspecialchars($label_reverse_display,ENT_QUOTES);
	$label_sign_gb = htmlspecialchars($label_sign_gb,ENT_QUOTES);
	$label_admin_menu = htmlspecialchars($label_admin_menu,ENT_QUOTES);
	if (whoami() && $show_admin_menu) $admin_menu = "&nbsp;&nbsp;|&nbsp;&nbsp;<a href=\"admin.php\" onMouseOver='status=\"$label_admin_menu\";return true;' onClick=\"if (this.blur) this.blur();\">$label_admin_menu</a>";
	else $admin_menu = "";
	
	if ($theme_by_language) $theme_position = "";
	else $theme_position = "</td><td align=right>";
	if ($use_languages && $use_themes) $lang_theme = "<tr><td>$label_language:&nbsp;&nbsp;$lang_sb".$theme_position."$label_theme:&nbsp;&nbsp;$theme_sb</td></tr>";
	else if ($use_languages) $lang_theme = "<tr><td colspan=2>$label_language:&nbsp;&nbsp;$lang_sb</td></tr>";
	else if ($use_themes) $lang_theme = "<tr><td colspan=2>$label_theme:&nbsp;&nbsp;$theme_sb</td></tr>";
	else $lang_theme = "";

	$legend_row1 = 'echo "<table style=\"background-color:$Vwindow_title_background_color;color:$Vwindow_title_text_color;\" height=\"1%\" width=\"$Vtable_width\" cellpadding=$Vwindow_cellpadding cellspacing=$Vwindow_cellspacing border=$Vwindow_border rules=none>";';
	$legend_row2 = 'echo $lang_theme;'; 
	$legend_row3 = 'echo "<tr><td align=left style=\"background-color:$Vwindow_title_background_color;color:$Vwindow_title_text_color;\"><a href=\"$PHP_SELF?action=add\" onMouseOver=\'status=\"$label_sign_gb\";return true;\' onClick=\"if (this.blur) this.blur();\">$label_sign_gb</a>$admin_menu</td><td align=right>$entries $label_entries_public";
	if ($show_private_entries_total) echo "&nbsp;&nbsp;|&nbsp;&nbsp;$private_entries $label_entries_private";';
	$legend_row4 = 'echo "</td></tr></table>";';

	$display_code = 'if ($tmp_data[$rn][0]>0) {$icons = "";								
	$idselector++;
	if ($idselector%2) {$id="td1";$hic = $Vwindow_hilite_color1; $hitc = $Vwindow_hilite_text_color1;} else {$id = "td2"; $hic = $Vwindow_hilite_color2; $hitc = $Vwindow_hilite_text_color2;}
	$cnti = 1;
	if ($show_nation && $tmp_data[$rn][12]>"" && $tmp_data[$rn][12]!="blank.gif" && !$hide_all) {$icons .=  "<a href=\"javascript:void(0)\" onClick=\"if (this.blur) this.blur();\" onMouseOver=\"status=\'".$tmp_data[$rn][12]."\';return true;\"><img border=0   src=\"$path_to_images/flags/".$tmp_data[$rn][12]."\"></a>&nbsp;&nbsp;"; if ($icons_in_separate_column) {$cnti++; if ($cnti>3) {$icons .= "<br>"; $cnti = 1;}}}
	if ($show_email && $tmp_data[$rn][5]>"" && !$hide_all) {$icons .= "<a href=\"mailto:".$tmp_data[$rn][5]."\" onClick=\"if (this.blur) this.blur();\"><img border=0   src=\"$path_to_images/$img_email\"></a>&nbsp;&nbsp;"; if ($icons_in_separate_column) {$cnti++; if ($cnti>3) {$icons .= "<br>"; $cnti = 1;}}}
	if ($show_home&&$tmp_data[$rn][6]>""&&!$hide_all) {$icons .= "<a target=_new href=\"http://".$tmp_data[$rn][6]."\" onClick=\"if (this.blur) this.blur();\"><img border=0   src=\"$path_to_images/$img_home\"></a>&nbsp;&nbsp;"; if ($icons_in_separate_column) {$cnti++; if ($cnti>3) {$icons .= "<br>"; $cnti = 1;}}}
	if ($show_pic&&$tmp_data[$rn][7]>""&&!$hide_all) {$icons .= "<a target=_new href=\"http://".$tmp_data[$rn][7]."\" onClick=\"if (this.blur) this.blur();\"><img border=0   src=\"$path_to_images/$img_pic\"></a>&nbsp;&nbsp;"; if ($icons_in_separate_column) {$cnti++; if ($cnti>3) {$icons .= "<br>"; $cnti = 1;}}}
	if ($show_icq&&$tmp_data[$rn][8]>""&&!$hide_all) {$icons .= "<a href=\"javascript:void(0)\" onClick=\"if (this.blur) this.blur();\" onMouseOver=\"status=\'".$tmp_data[$rn][8]."\';return true;\"><img border=0   src=\"$path_to_images/$img_icq\"></a>&nbsp;&nbsp;"; if ($icons_in_separate_column) {$cnti++; if ($cnti>3) {$icons .= "<br>"; $cnti = 1;}}}
	if ($show_aim&&$tmp_data[$rn][9]>""&&!$hide_all) {$icons .= "<a href=\"javascript:void(0)\" onClick=\"if (this.blur) this.blur();\" onMouseOver=\"status=\'".$tmp_data[$rn][9]."\';return true;\"><img border=0   src=\"$path_to_images/$img_aim\"></a>&nbsp;&nbsp;"; if ($icons_in_separate_column) {$cnti++; if ($cnti>3) {$icons .= "<br>"; $cnti = 1;}}}
	if ($show_yim&&$tmp_data[$rn][10]>""&&!$hide_all) {$icons .= "<a href=\"javascript:void(0)\" onClick=\"if (this.blur) this.blur();\" onMouseOver=\"status=\'".$tmp_data[$rn][10]."\';return true;\"><img border=0   src=\"$path_to_images/$img_yim\"></a>&nbsp;&nbsp;"; if ($icons_in_separate_column) {$cnti++; if ($cnti>3) {$icons .= "<br>"; $cnti = 1;}}}
	if ($show_msn&&$tmp_data[$rn][11]>""&&!$hide_msn) {$icons .= "<a href=\"javascript:void(0)\" onClick=\"if (this.blur) this.blur();\" onMouseOver=\"status=\'".$tmp_data[$rn][11]."\';return true;\"><img border=0   src=\"$path_to_images/$img_msn\"></a>&nbsp;&nbsp;"; if ($icons_in_separate_column) {$cnti++; if ($cnti>3) {$icons .= "<br>"; $cnti = 1;}}}
	if ($show_ip&&$tmp_data[$rn][1]>""&&!$hide_all) {$icons .= "<a href=\"javascript:void(0)\" onClick=\"if (this.blur) this.blur();\" onMouseOver=\"status=\'".$tmp_data[$rn][1]."\';return true;\"><img border=0   src=\"$path_to_images/$img_ip\"></a>&nbsp;&nbsp;"; if ($icons_in_separate_column) {$cnti++; if ($cnti>3) {$icons .= "<br>"; $cnti = 1;}}}
	echo "<tr>";
	$colspan = "";
	if (!($show_name || $show_email || $show_home || $show_pic || $show_icq || $show_aim || $show_yim || $show_msn || $show_nation || $show_ip)) $hide_all = true;
	if ($icons>"" && !$hide_all) $colspan = "";
	else $colspan = " colspan=2 ";
	if ($icons_in_separate_column AND !$hide_all) 
	{
		echo "<td id=\"$id\" align=left valign=top width=$Vtable_icon_cell_size>";	
		echo $icons;
		echo "</td>";
	}
	echo "<td id=\"$id\" valign=top align=left $colspan>";
	echo "<span style=\"background-color:$hic;color:$hitc;width:100%;\"><b><em>&nbsp;".$tmp_data[$rn][4]."</em></b> $label_comments_added $on ".$tmp_data[$rn][2]." $at ".$tmp_data[$rn][3]; if (!$icons_in_separate_column) {echo "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;$icons";} echo "</span><br>";
	$tmp_data[$rn][13] = stripslashes($tmp_data[$rn][13]);
	$tmp_data[$rn][13] = str_replace("&lt;","<",$tmp_data[$rn][13]);
	$tmp_data[$rn][13] = str_replace("&gt;",">",$tmp_data[$rn][13]);
	$allow_tags = "";
	if ($allow_html) $allow_tags .= $allowed_html_tags_no_img;
	if ($allow_smileys) $allow_tags .= "<img>";
	$tmp_data[$rn][13] = strip_tags($tmp_data[$rn][13],$allow_tags); 
	echo "<br>";				
	echo $tmp_data[$rn][13]."</td></tr>";

	}';
	
	eval($legend_row1);
	if ($use_themes_languages_header) eval($legend_row2);
	eval($legend_row3);
	eval($legend_row4);	
	echo "\n\n<table width=\"$Vtable_width\" height=\"$Vtable_height\" cellpadding=$Vwindow_cellpadding cellspacing=$Vwindow_cellspacing border=$Vwindow_border>";

	$trn = $rn;
	if (!isset($start)) $start=$rn;
	$rn = $start;
	$rows_per_page = ($rows_per_page>0)?$rows_per_page:99999;

		$cnt = 0;
		for ($c=$rn;$c>0;$c--) {
			if ($tmp_data[$rn][14]=="on" && $tmp_data[$rn][0]>0);	
			else if ($cnt==0 OR $cnt%$rows_per_page!=0) {
				eval($display_code);
				$cnt++;
			}
			$rn--;
			if ($cnt > 0 AND $cnt%$rows_per_page==0) {
				$next = $rn;
				break;
			}
		}
		if ($next < 1) $prev = $cnt + $rows_per_page;
		else $prev = $next + 2*($rows_per_page);
		if ($prev > $trn) $prev = $trn;
		if ($prev <= $rows_per_page) $prev = 0;
		
		if ($next>0 OR $next>$rows_per_page) $show_next=true;
		else $show_next=false;
		if ($prev>0 && ($start!=$trn OR $show_next==false)) $show_prev=true;
		else $show_prev=false;

	if ($next<$rows_per_page) $nrpp = $next;
	else $nrpp = $rows_per_page;
	if ($prev<$rows_per_page) $prpp = $prev;
	else $prpp = $rows_per_page;

	echo "</table>\n\n";
	$data = array();
	$tmp_data = array();
	if ($entries>0) {
		eval($legend_row1);
		if ($use_themes_languages_footer) eval($legend_row2);
		eval($legend_row3);
		echo "<tr><td colspan=2 valign=top align=$next_prev_position>";
		if ($show_prev) echo "<a href=\"$PHP_SELF?start=$prev\" onMouseOver='status=\"$label_previous $prpp\";return true;'>$label_previous $prpp</a>";
		if ($show_prev && $show_next) echo "&nbsp;&nbsp;|&nbsp;&nbsp"; 
		if ($show_next) echo "<a href=\"$PHP_SELF?start=$next\" onMouseOver='status=\"$label_next $nrpp\";return true;'>$label_next $nrpp</a>";
		if ($rn>0) echo "&nbsp;&nbsp;&nbsp;&nbsp;( $rn $label_remaining )";
	}
	else {
		echo "<span style=\"background-color:$hic;color:$hitc;width:100%;\">";
		echo "<tr><td colspan=2 valign=top align=$next_prev_position>";
		if ($show_prev) echo "<a href=\"$PHP_SELF?start=$prev\" onMouseOver='status=\"$label_previous $prpp\";return true;'>$label_previous $prpp</a>";
		if ($show_prev && $show_next) echo "&nbsp;&nbsp;|&nbsp;&nbsp"; 
		if ($show_next) echo "<a href=\"$PHP_SELF?start=$next\" onMouseOver='status=\"$label_next $nrpp\";return true;'>$label_next $nrpp</a>";
		if ($rn>0) echo "&nbsp;&nbsp;&nbsp;&nbsp;( $rn $label_remaining )";
	}
	eval($legend_row4);
	if ($use_intro) {
		echo "<table style=\"font-size:$Intro_font_size;color:$Intro_text_color;background-color:$Intro_background_color;color:$Intro_text_color;border-color:$Intro_border_color;\" width=\"$Intro_width\" height=\"1%\" border=\"$Intro_border\" rules=none cellpadding=0 cellspacing=0><tr><td><b>&nbsp;</b></td></tr></table>";
	}

	echo "</center>";
}  
#end action=view
###############################################################
# PLEASE NOTE: AS STATED IN THE README FILE, THE FOOTER MUST  #
# OR YOU ARE IN VIOLATION OF THE USAGE AGREEMENT AND LICENSE. #
###############################################################
require 'footer.php';
?>
</form>
</body>
</html>
